#include <ctype.h>
#include "bmsfel_p.h"

//################################################
// IuWF1

//////////////////////////////////////////////////
// RXgN^Q
BmsWord::BmsWord() {
  this->set( '0', '0' );
}

BmsWord::BmsWord( int x ) {
  this->set( x );
}

BmsWord::BmsWord( const char *str ) {
  this->set( str );
}

BmsWord::BmsWord( char msb, char lsb ) {
  this->set( msb, lsb );
}

// fXgN^
BmsWord::~BmsWord() {
}

//////////////////////////////////////////////////
// setn
void BmsWord::set( int x ) {
  if ( x < 0 || BMS_WORD_MAX < x ) { x = 0; }
  this->set( BmsUtil::int_to_hex36( x / HEX36_MAX ),
             BmsUtil::int_to_hex36( x % HEX36_MAX ) );
}

void BmsWord::set( const char *str ) {
  this->set( *(str), *(str + 1) );
}

void BmsWord::set( char msb, char lsb ) {
  if ( isalnum( msb ) == false ) { msb = '0'; }
  this->msb = (char)toupper( msb );
  if ( isalnum( lsb ) == false ) { lsb = '0'; }
  this->lsb = (char)toupper( lsb );
}

//////////////////////////////////////////////////
// getn
int BmsWord::get_int() const {
  return BmsUtil::hex36_to_int( this->msb, this->lsb );
}

char BmsWord::get_msb() const {
  return this->msb;
}

char BmsWord::get_lsb() const {
  return this->lsb;
}

char *BmsWord::get_str( char *str ) const {
  this->get_char( str, str + 1 );
  return str;
}

char *BmsWord::get_str_null( char *str ) const {
  this->get_str( str );
  str[2] = '\0';
  return str;
}

void BmsWord::get_char( char *msb, char *lsb ) const {
  *(msb) = this->msb;
  *(lsb) = this->lsb;
}


//////////////////////////////////////////////////
// ZQ
void BmsWord::operator ++() {
  this->succ();
}

void BmsWord::next() {
  this->succ();
}

void BmsWord::succ() {
  this->add( 1 );
}

void BmsWord::add( int num ) {
  int temp;
  temp = this->get_int() + ( num % BMS_WORD_MAX );
  if( temp < 0           ) { temp += BMS_WORD_MAX; }
  if( temp > BMS_WORD_MAX ) { temp -= BMS_WORD_MAX; }
  this->set( temp );
}

//////////////////////////////////////////////////
// ZQ
void BmsWord::operator --() {
  this->prev();
}

void BmsWord::prev() {
  this->sub( 1 );
}

void BmsWord::sub( int num ) {
  this->add( -num );
}

//////////////////////////////////////////////////
// rQ
bool BmsWord::operator ==( int x ) const {
  return this->equal( x );
}
bool BmsWord::operator !=( int x ) const {
  return !( this->equal( x ) );
}

bool BmsWord::operator ==( char *str ) const {
  return this->equal( str );
}
bool BmsWord::operator !=( char *str ) const {
  return !( this->equal( str ) );
}

bool BmsWord::operator ==( BmsWord obj ) const {
  return this->equal( obj );
}
bool BmsWord::operator !=( BmsWord obj ) const {
  return !( this->equal( obj ) );
}

bool BmsWord::equal( int x ) const {
  if ( x < 0 || BMS_WORD_MAX < x ) { return false; }
  return this->equal( BmsUtil::int_to_hex36( x / HEX36_MAX ),
                      BmsUtil::int_to_hex36( x % HEX36_MAX ) );
}

bool BmsWord::equal( char *str ) const {
  return this->equal( *(str), *(str + 1) );
}

bool BmsWord::equal( BmsWord obj ) const {
  return this->equal( obj.msb, obj.lsb );
}

// ǂ==n͑SĂł
bool BmsWord::equal( char msb, char lsb ) const {
  return this->msb == msb && this->lsb == lsb;
}


//////////////////////////////////////////////////
// <= < >= >n  comparenĂ

//////////////////////////////////////////////////
// <=n
bool BmsWord::operator <=( int x ) const {
  return this->compare( x ) <= 0;
}

bool BmsWord::operator <=( char *str ) const {
  return this->compare( str ) <= 0;
}

bool BmsWord::operator <=( BmsWord obj ) const {
  return this->compare( obj ) <= 0;
}

//////////////////////////////////////////////////
// <n
bool BmsWord::operator <( int x ) const {
  return this->compare( x ) < 0;
}

bool BmsWord::operator <( char *str ) const {
  return this->compare( str ) < 0;
}

bool BmsWord::operator <( BmsWord obj ) const {
  return this->compare( obj ) < 0;
}

//////////////////////////////////////////////////
// >= n
bool BmsWord::operator >=( int x ) const {
  return this->compare( x ) >= 0;
}

bool BmsWord::operator >=( char *str ) const {
  return this->compare( str ) >= 0;
}

bool BmsWord::operator >=( BmsWord obj ) const {
  return this->compare( obj ) >= 0;
}

//////////////////////////////////////////////////
// >n
bool BmsWord::operator >( int x ) const {
  return this->compare( x ) > 0;
}

bool BmsWord::operator >( char *str ) const {
  return this->compare( str ) > 0;
}

bool BmsWord::operator >( BmsWord obj ) const {
  return this->compare( obj ) > 0;
}


//////////////////////////////////////////////////
// rĂ̍Ԃ
int BmsWord::compare( int x ) const {
  return this->get_int() - x;
}

int BmsWord::compare( char *str ) const {
  return this->compare( *(str), *(str + 1) );
}

int BmsWord::compare( BmsWord obj ) const {
  return this->compare( obj.msb, obj.lsb );
}

int BmsWord::compare( char msb, char lsb ) const {
  return this->compare( BmsUtil::hex36_to_int( msb, lsb ) );
}
